
///////////////////////////////////////////////////////////////////////
// Module       : TP CORBA 1999
// Composant    : Serveur.java
// Creation     : 09/03/1999
//
// Commentaires :  Code d'un serveur exportant un objet CORBA (voir
//		   tpcorba.idl)
// MOD1         :
///////////////////////////////////////////////////////////////////////
// $Id: Serveur.java,v 1.2 1999/03/12 14:22:29 singhoff Exp singhoff $
///////////////////////////////////////////////////////////////////////


package tpcorba;

import org.omg.CORBA.*;
import java.util.*;
import java.io.*;
import java.lang.*;

public class Serveur 
	{
	public static void main(String args[]) throws IOException
		{ 

		////////////////////////////////////////
		// Initialisation de l'ORB et de la BOA 
		////////////////////////////////////////

		Properties props = System.getProperties();
		props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
		props.put("org.omg.CORBA.ORBSingletonClass",
			"com.ooc.CORBA.ORBSingleton");
		System.setProperties(props);


		ORB orb = ORB.init(args, props);
		BOA boa = ((com.ooc.CORBA.ORB)orb).BOA_init(args, props);




		////////////////////////////////////////////////////////////////
		// Instantiation de l'objet : creation de 
		//	l'implantation de l'objet
		////////////////////////////////////////////////////////////////
  
		calcul_Impl calc = new calcul_Impl();
      		try
			{
	  		String calc_ref = orb.object_to_string(calc);
	  		String refFile = "calcul.ref";
	  		PrintWriter out = new PrintWriter(new FileOutputStream(refFile));
	  		out.println(calc_ref);
	  		out.close();
			}
      		catch(IOException ex)
			{
	  		System.err.println("Impossible d'ecrire la reference dans calcul.ref");
	  		System.exit(1);
			}


		////////////////////////////////////////////////////////////////
		// Activation de l'objet : l'objet est maintenant connu de 
		// la BOA ; il peut donc etre invoque par un client
		////////////////////////////////////////////////////////////////
		
		boa.obj_is_ready(calc,null);



		////////////////////////////////////////////////////////////////
		// Lancement de la BOA : par partir de cet instant, le serveur
		// est capable de traiter les requetes sur les objets deja
		// actives ainsi que ceux qui le seront par la suite
		// La methode "impl_is_ready" est bloquante
		// Cette methode est equivalent au "select" pour des sockets 
		////////////////////////////////////////////////////////////////

	  	System.out.println("Le serveur est pret ");

  		boa.impl_is_ready(null);
      
  
		System.exit(0);
		}


	}


