
///////////////////////////////////////////////////////////////////////
// Module 	: TP CORBA JAVA
// Composant 	: Client.java
// Creation 	: 09/03/1999
//
// Commentaires :  Code d'un client java invoquant un objet CORBA
// MOD1		:
///////////////////////////////////////////////////////////////////////
// $Id: Client.java,v 1.1 1999/03/12 14:24:30 singhoff Exp singhoff $
///////////////////////////////////////////////////////////////////////

package tpcorba;

import org.omg.CORBA.*;
import java.lang.*;
import java.util.*;
import java.io.*;



public class Client
	{


	public static void main(String args[]) throws IOException 
		{ 


		////////////////////////////////////////////////////
		// On initialise l'ORB
		////////////////////////////////////////////////////

		Properties props = System.getProperties();
		props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
		props.put("org.omg.CORBA.ORBSingletonClass",
			"com.ooc.CORBA.ORBSingleton");
		System.setProperties(props);

		ORB orb = ORB.init(args, props);



		if(args.length!=0)
			{
			System.err.println("utilisation sans parametre ");
			System.exit(1);
			}


		////////////////////////////////////////////////////
		// Recuperation de la reference d'objet du serveur
		// Dans cet exemple, la reference est stockee sous
		// la forme d'une chaine de caractere (IOR) dans un
		// fichier. A ce stade, il est bien sur possible 
		// d'invoquer un service de nommage.
		////////////////////////////////////////////////////
      
		String ior = null;
		try
			{
			String ref = "calcul.ref";
			FileInputStream file = new FileInputStream(ref);
			BufferedReader in = new BufferedReader(new InputStreamReader(file));
			ior = in.readLine();
			file.close();
			}
		catch(IOException ex)
			{
			System.err.println("Impossible de lire fichier : `" +
				ex.getMessage() + "'");
			System.exit(1);
			}
      

		////////////////////////////////////////////////////
		// Construction d'une reference d'objet, non type d'abord,
		// puis "converti" en une reference sur l'interface 
		// "calcul"  avec le narrow (operation de "cast" dynamique)
		////////////////////////////////////////////////////
	
		org.omg.CORBA.Object obj = orb.string_to_object(ior);
		if(obj==null)
			{
			System.err.println("Erreur sur string_to_object() ");
			throw new RuntimeException();
			}
      

		tpcorba.calcul calc = tpcorba.calculHelper.narrow(obj);
		if(calc==null)
			{
			System.err.println("Erreur sur narrow() ");
			throw new RuntimeException();
			}


		////////////////////////////////////////////////////
		// Invocations du serveur
		////////////////////////////////////////////////////

      		try
			{


				*** Afficher l'etat initial de la 
				*** memoire de la calculatrice


				*** Ajouter ici des operations sur la 
				*** memoire de la calculatrice 


				*** Afficher l'etat final de la 
				*** memoire de la calculatrice


				// Regarder le fonctionnement des 
				// exceptions
				//
				calc.diviseMemoire(0);


				System.exit(0);

			}
		catch(divisionParZero ex)
			{
			System.err.println("Exception : division par zero" );
			System.exit(1);
			}
		}
}

